/*!
 * SAP UI development toolkit for HTML5 (SAPUI5/OpenUI5)
 * (c) Copyright 2009-2015 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/layout/Grid','sap/ui/layout/GridData','./FormLayout','sap/ui/layout/library'],function(q,G,a,F,l){"use strict";var R=F.extend("sap.ui.layout.form.ResponsiveGridLayout",{metadata:{library:"sap.ui.layout",properties:{labelSpanL:{type:"int",group:"Misc",defaultValue:4},labelSpanM:{type:"int",group:"Misc",defaultValue:2},labelSpanS:{type:"int",group:"Misc",defaultValue:12},emptySpanL:{type:"int",group:"Misc",defaultValue:0},emptySpanM:{type:"int",group:"Misc",defaultValue:0},emptySpanS:{type:"int",group:"Misc",defaultValue:0},columnsL:{type:"int",group:"Misc",defaultValue:2},columnsM:{type:"int",group:"Misc",defaultValue:1},breakpointL:{type:"int",group:"Misc",defaultValue:1024},breakpointM:{type:"int",group:"Misc",defaultValue:600}}}});sap.ui.core.Control.extend("sap.ui.layout.form.ResponsiveGridLayoutPanel",{metadata:{aggregations:{"content":{type:"sap.ui.layout.Grid",multiple:false}},associations:{"container":{type:"sap.ui.layout.form.FormContainer",multiple:false},"layout":{type:"sap.ui.layout.form.ResponsiveLayout",multiple:false}}},getLayoutData:function(){var c=sap.ui.getCore().byId(this.getContainer());var L=sap.ui.getCore().byId(this.getLayout());var o;if(L&&c){o=L.getLayoutDataForElement(c,"sap.ui.layout.GridData");}if(o){return o;}else{return this.getAggregation("layoutData");}},getCustomData:function(){var c=sap.ui.getCore().byId(this.getContainer());if(c){return c.getCustomData();}},refreshExpanded:function(){var c=sap.ui.getCore().byId(this.getContainer());if(c){if(c.getExpanded()){this.$().removeClass("sapUiRGLContainerColl");}else{this.$().addClass("sapUiRGLContainerColl");}}},renderer:function(r,p){var c=sap.ui.getCore().byId(p.getContainer());var L=sap.ui.getCore().byId(p.getLayout());var C=p.getContent();var e=c.getExpandable();var t=c.getTooltip_AsString();r.write("<div");r.writeControlData(p);r.addClass("sapUiRGLContainer");if(e&&!c.getExpanded()){r.addClass("sapUiRGLContainerColl");}if(t){r.writeAttributeEscaped('title',t);}r.writeClasses();L.getRenderer().writeAccessibilityStateContainer(r,c);r.write(">");if(c.getTitle()){L.getRenderer().renderTitle(r,c.getTitle(),c._oExpandButton,e,false,c.getId());}if(C){r.write("<div");r.addClass("sapUiRGLContainerCont");r.writeClasses();r.write(">");r.renderControl(C);r.write("</div>");}r.write("</div>");}});(function(){R.prototype.init=function(){this.mContainers={};this.oDummyLayoutData=new a(this.getId()+"--Dummy");this.SPANPATTERN=/^([L](?:[1-9]|1[0-2]))? ?([M](?:[1-9]|1[0-2]))? ?([S](?:[1-9]|1[0-2]))?$/i;};R.prototype.exit=function(){var t=this;for(var C in this.mContainers){h(t,C);}if(this._mainGrid){this._mainGrid.destroy();delete this._mainGrid;}this.oDummyLayoutData.destroy();this.oDummyLayoutData=undefined;};R.prototype.onBeforeRendering=function(E){var o=this.getParent();if(!o||!(o instanceof sap.ui.layout.form.Form)){return;}o._bNoInvalidate=true;var t=this;_(t,o);k(t,o);o._bNoInvalidate=false;};R.prototype.onAfterRendering=function(E){if(this._mainGrid&&this._mainGrid.__bIsUsed){for(var C in this.mContainers){if(this.mContainers[C][1]._sContainerResizeListener){sap.ui.core.ResizeHandler.deregister(this.mContainers[C][1]._sContainerResizeListener);this.mContainers[C][1]._sContainerResizeListener=null;}}}};R.prototype.contentOnAfterRendering=function(o,C){F.prototype.contentOnAfterRendering.apply(this,arguments);if(C.getWidth&&(!C.getWidth()||C.getWidth()=="auto")&&C.getMetadata().getName()!="sap.ui.commons.Image"){C.$().css("width","100%");}};R.prototype.toggleContainerExpanded=function(C){var s=C.getId();if(this.mContainers[s]&&this.mContainers[s][0]){var p=this.mContainers[s][0];p.refreshExpanded();}};R.prototype.onLayoutDataChange=function(E){var s=E.srcControl;if(s instanceof sap.ui.layout.form.FormContainer){if(this._mainGrid){this._mainGrid.onLayoutDataChange(E);}}else if(!(s instanceof sap.ui.layout.form.FormElement)){var p=s.getParent();if(p instanceof sap.ui.layout.form.FormElement){var C=p.getParent();var i=C.getId();if(this.mContainers[i]&&this.mContainers[i][1]){this.mContainers[i][1].onLayoutDataChange(E);}}}};R.prototype.onsapup=function(E){this.onsapleft(E);};R.prototype.onsapdown=function(E){this.onsapright(E);};function _(L,o){var C=o.getFormContainers();var j=C.length;var v=0;var V=0;var n=[];var p;var r;var s;var t;var i=0;for(i=0;i<j;i++){s=C[i];s._checkProperties();if(s.getVisible()){v++;n.push(s);}}for(i=0;i<v;i++){s=n[i];if(s.getVisible()){V++;t=s.getId();p=undefined;r=undefined;var u=n[i+1];if(L.mContainers[t]&&L.mContainers[t][1]){r=L.mContainers[t][1];}else{r=d(L,s);}var T=s.getTitle();if(T||s.getExpandable()){if(L.mContainers[t]&&L.mContainers[t][0]){p=L.mContainers[t][0];}else{p=b(L,s,r);f(r,true);}g(p,s,V,u,v);}else{if(L.mContainers[t]&&L.mContainers[t][0]){c(L.mContainers[t][0]);}f(r,false);g(r,s,V,u,v);}L.mContainers[t]=[p,r];}}var O=m(L.mContainers);if(v<O){for(t in L.mContainers){var w=false;for(i=0;i<j;i++){s=C[i];if(t==s.getId()&&s.getVisible()){w=true;break;}}if(!w){h(L,t);}}}}function b(L,C,o){var s=C.getId();var p=new sap.ui.layout.form.ResponsiveGridLayoutPanel(s+"---Panel",{container:C,layout:L,content:o});return p;}function c(p){p.setContent("");p.setLayout("");p.setContainer("");p.destroy();}function d(L,C){var I=C.getId()+"--Grid";var o=new G(I,{vSpacing:0,hSpacing:0,containerQuery:true});o.__myParentLayout=L;o.__myParentContainerId=C.getId();o.addStyleClass("sapUiFormResGridCont");o.getContent=function(){var C=sap.ui.getCore().byId(this.__myParentContainerId);if(C){var n=[];var E=C.getFormElements();var p;var r;for(var i=0;i<E.length;i++){var s=E[i];if(s.getVisible()){r=s.getLabelControl();if(r){n.push(r);}p=s.getFields();for(var j=0;j<p.length;j++){n.push(p[j]);}}}return n;}else{return false;}};o._getLayoutDataForControl=function(j){var L=this.__myParentLayout;var n=L.getLayoutDataForElement(j,"sap.ui.layout.GridData");var E=j.getParent();var p=E.getLabelControl();if(n){if(p==j){n._setStylesInternal("sapUiFormResGridLbl");}return n;}else{var C=sap.ui.getCore().byId(this.__myParentContainerId);var r=L.getLayoutDataForElement(C,"sap.ui.layout.GridData");var s=C.getParent();var t=L.getLabelSpanL();var u=L.getLabelSpanM();var v=L.getLabelSpanS();if(s.getFormContainers().length>=1&&L.getColumnsM()>1){u=L.getLabelSpanL();}if(r){if(r._getEffectiveSpanLarge()==12){t=L.getLabelSpanM();u=L.getLabelSpanM();}}if(s.getFormContainers().length==1||L.getColumnsL()==1){t=L.getLabelSpanM();u=L.getLabelSpanM();}if(p==j){L.oDummyLayoutData.setSpan("L"+t+" M"+u+" S"+v);L.oDummyLayoutData.setLinebreak(true);L.oDummyLayoutData._setStylesInternal("sapUiFormResGridLbl");return L.oDummyLayoutData;}else{var w=12-L.getEmptySpanL();var M=12-L.getEmptySpanM();var S=12-L.getEmptySpanS();var x;if(p){var y=L.getLayoutDataForElement(p,"sap.ui.layout.GridData");if(y){x=y._getEffectiveSpanLarge();if(x){t=x;}x=y._getEffectiveSpanMedium();if(x){u=x;}x=y._getEffectiveSpanSmall();if(x){v=x;}}if(t<12){w=w-t;}if(u<12){M=M-u;}if(v<12){S=S-v;}}var z=E.getFields();var A=z.length;var D=1;var B=false;for(var i=0;i<A;i++){var H=z[i];if(H!=j){var J=L.getLayoutDataForElement(H,"sap.ui.layout.GridData");if(J){x=J._getEffectiveSpanLarge();if(x&&x<w){w=w-x;}x=J._getEffectiveSpanMedium();if(x&&x<M){M=M-x;}x=J._getEffectiveSpanSmall();if(x&&x<S){S=S-x;}}else{D++;}}else{if(D==1){B=true;}}}var K,N,O=12;if(B){var P=w-Math.floor(w/D)*D;K=Math.floor(w/D)+P;P=M-Math.floor(M/D)*D;N=Math.floor(M/D)+P;if(v<12){P=S-Math.floor(S/D)*D;O=Math.floor(S/D)+P;}}else{K=Math.floor(w/D);N=Math.floor(M/D);if(v<12){O=Math.floor(S/D);}}L.oDummyLayoutData.setSpan("L"+K+" M"+N+" S"+O);L.oDummyLayoutData.setLinebreak(B&&!p);L.oDummyLayoutData._setStylesInternal(undefined);return L.oDummyLayoutData;}return n;}};o._onParentResizeOrig=o._onParentResize;o._onParentResize=function(){if(!this.getDomRef()){this._cleanup();return;}if(!q(this.getDomRef()).is(":visible")){return;}var L=this.__myParentLayout;if(!L._mainGrid||!L._mainGrid.__bIsUsed){var i=L.getParent().getFormContainers();if(!L.mContainers[i[0].getId()]||i[0].getId()!=this.__myParentContainerId){return;}if(L.mContainers[this.__myParentContainerId][0]){var D=L.mContainers[this.__myParentContainerId][0].getDomRef();var j=D.clientWidth;if(j<=L.getBreakpointM()){this._toggleClass("Phone");}else if((j>L.getBreakpointM())&&(j<=L.getBreakpointL())){this._toggleClass("Tablet");}else{this._toggleClass("Desktop");}}else{this._setBreakPointTablet(L.getBreakpointM());this._setBreakPointDesktop(L.getBreakpointL());this._onParentResizeOrig();}}else{var $=L._mainGrid.$();if($.hasClass("sapUiRespGridMedia-Std-Phone")){this._toggleClass("Phone");}else if($.hasClass("sapUiRespGridMedia-Std-Tablet")){this._toggleClass("Tablet");}else{this._toggleClass("Desktop");}}};o._getAccessibleRole=function(){var C=sap.ui.getCore().byId(this.__myParentContainerId);if(!C.getTitle()&&!C.getExpandable()){return"form";}};return o;}function e(o){if(o.__myParentContainerId){o.__myParentContainerId=undefined;}o.__myParentLayout=undefined;o.destroy();}function f(o,O){if(O){if(o.__originalGetLayoutData){o.getLayoutData=o.__originalGetLayoutData;delete o.__originalGetLayoutData;}}else if(!o.__originalGetLayoutData){o.__originalGetLayoutData=o.getLayoutData;o.getLayoutData=function(){var L=this.__myParentLayout;var C=sap.ui.getCore().byId(this.__myParentContainerId);var i;if(C){i=L.getLayoutDataForElement(C,"sap.ui.layout.GridData");}if(i){return i;}else{return this.getAggregation("layoutData");}};}}function g(C,o,v,i,V){var L;if(C instanceof sap.ui.layout.form.ResponsiveGridLayoutPanel){L=sap.ui.getCore().byId(C.getLayout());}else{L=C.__myParentLayout;}var j=L.getColumnsL();var n=L.getColumnsM();var p=L.getLayoutDataForElement(o,"sap.ui.layout.GridData");if(!p){var r=(v%j)==1;var s=(v%j)==0;var t=v>(V-j+(V%j));var u=(v%n)==1;var w=(v%n)==0;var x=v>(V-n+(V%n));if(i){var y=L.getLayoutDataForElement(i,"sap.ui.layout.GridData");if(y&&(y.getLinebreak()||y.getLinebreakL())){s=true;t=false;}if(y&&(y.getLinebreak()||y.getLinebreakM())){w=true;x=false;}}var S="";if(s){S="sapUiFormResGridLastContL";}if(w){if(S){S=S+" ";}S=S+"sapUiFormResGridLastContM";}if(t){if(S){S=S+" ";}S=S+"sapUiFormResGridLastRowL";}if(x){if(S){S=S+" ";}S=S+"sapUiFormResGridLastRowM";}p=C.getLayoutData();if(!p){p=new a(C.getId()+"--LD",{linebreakL:r,linebreakM:u});C.setLayoutData(p);}else{p.setLinebreakL(r);p.setLinebreakM(u);}p._setStylesInternal(S);}}function h(L,C){var i=L.mContainers[C];var o=i[1];if(o){e(o);}var p=i[0];if(p){c(p);}delete L.mContainers[C];}function k(L,o){var C=o.getFormContainers();var j;var n=0;var p=0;var i=0;for(i=0;i<C.length;i++){j=C[i];if(j.getVisible()){n++;}}if(n>1){var s=Math.floor(12/L.getColumnsL());var S=Math.floor(12/L.getColumnsM());if(!L._mainGrid){L._mainGrid=new G(o.getId()+"--Grid",{defaultSpan:"L"+s+" M"+S+" S12",hSpacing:0,vSpacing:0,containerQuery:true}).setParent(L);L._mainGrid.addStyleClass("sapUiFormResGridMain");L._mainGrid._onParentResizeOrig=L._mainGrid._onParentResize;L._mainGrid._onParentResize=function(){this._onParentResizeOrig();for(var v in L.mContainers){L.mContainers[v][1]._onParentResize();}};}else{L._mainGrid.setDefaultSpan("L"+s+" M"+S+" S12");var r=L._mainGrid.getContent();p=r.length;var E=false;for(i=0;i<p;i++){var t=r[i];j=undefined;if(t.getContainer){j=sap.ui.getCore().byId(t.getContainer());}else{j=sap.ui.getCore().byId(t.__myParentContainerId);}if(j&&j.getVisible()){var u=L.mContainers[j.getId()];if(u[0]&&u[0]!=t){E=true;break;}if(!u[0]&&u[1]&&u[1]!=t){E=true;break;}}else{L._mainGrid.removeContent(t);}}if(E){L._mainGrid.removeAllContent();p=0;}}L._mainGrid._setBreakPointTablet(L.getBreakpointM());L._mainGrid._setBreakPointDesktop(L.getBreakpointL());L._mainGrid.__bIsUsed=true;if(p<n){for(i=0;i<C.length;i++){j=C[i];if(j.getVisible()){var v=j.getId();if(L.mContainers[v]){if(L.mContainers[v][0]){L._mainGrid.addContent(L.mContainers[v][0]);}else if(L.mContainers[v][1]){L._mainGrid.addContent(L.mContainers[v][1]);}}}}}}else if(L._mainGrid){L._mainGrid.__bIsUsed=false;}}function m(o){var L=0;if(!Object.keys){q.each(o,function(){L++;});}else{L=Object.keys(o).length;}return L;}}());return R;},true);
