/*!
 * SAP UI development toolkit for HTML5 (SAPUI5/OpenUI5)
 * (c) Copyright 2009-2015 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/base/BindingParser'],function(q,B){'use strict';var A,r=/[\\\{\}:]/,a=/^(\/dataServices\/schema\/\d+\/entityType\/\d+)(?:\/|$)/,e=B.complexParser.escape;function b(I,p){var P=[],i,o;for(i=0;i<p.length;i+=1){o=p[i];if(o){switch(o.Type){case"Path":P.push(j(I,o.Value,true).value);break;case"String":P.push(d(o.Value));break;default:P.push("["+u(o)+"]");}}else{P.push("["+u(o)+"]");}}return P.join("");}function d(v){return e(String(v));}function f(i,R){var c;if(!R){return{result:"constant",value:u(R,true),type:"Edm.String"};}switch(R.Type){case"Path":return j(i,R.Value,false);case"String":return{result:"constant",value:R.Value,type:"Edm.String"};case undefined:if(R.Path){return j(i,R.Path,false);}break;}if(R.Apply&&typeof R.Apply==="object"){switch(R.Apply.Name){case"odata.uriEncode":c=l(i,R.Apply.Parameters);if(c){return{result:"expression",value:c.slice(2,-1),type:"Edm.String"};}break;}}return{result:"constant",value:u(R,true),type:"Edm.String"};}function g(I,p){var i,P=[],c,o;if(!q.isArray(p)||!p.length||!p[0]||p[0].Type!=="String"){return undefined;}P.push('{=odata.fillUriTemplate(');P.push(s(p[0].Value));P.push(', {');c="";for(i=1;i<p.length;i+=1){P.push(c);P.push(s(p[i].Name));P.push(": ");o=f(I,p[i].Value);switch(o.result){case"binding":P.push("$"+o.value);break;case"expression":P.push(o.value);break;default:P.push(s(o.value));}c=", ";}P.push("})}");return P.join("");}function h(i,R){var o,c,E,I,m,M=i.getModel(),p,P,n={associationSetEnd:undefined,navigationAfterMultiple:false,isMultiple:false,navigationProperties:[],resolvedPath:undefined},S;if(R&&R.hasOwnProperty("AnnotationPath")){P=R.AnnotationPath;}else if(R&&R.hasOwnProperty("Path")){P=R.Path;}else{return undefined;}m=a.exec(i.getPath());if(!m){return undefined;}c=m[1];p=P.split("/");while(P&&p.length&&c){S=p[0];I=S.indexOf("@");if(I===0){c+="/"+S.slice(1);p.shift();continue;}E=M.getObject(c);o=M.getODataAssociationEnd(E,S);if(o){n.associationSetEnd=M.getODataAssociationSetEnd(E,S);n.navigationProperties.push(S);if(n.isMultiple){n.navigationAfterMultiple=true;}n.isMultiple=o.multiplicity==="*";c=M.getODataEntityType(o.type,true);p.shift();continue;}c=M.getODataProperty(E,p,true);}n.resolvedPath=c;return n;}function j(i,p,w){var c={},m=i.getModel(),C=i.getPath(),M=a.exec(C),E,P,o,R={result:"binding"},t;if(M){E=m.getProperty(M[1]);P=p.split('/');o=m.getODataProperty(E,P);if(o&&!P.length){R.type=o.type;switch(o.type){case"Edm.Boolean":t='sap.ui.model.odata.type.Boolean';break;case"Edm.Byte":t='sap.ui.model.odata.type.Byte';break;case"Edm.DateTime":t='sap.ui.model.odata.type.DateTime';c.displayFormat=o["sap:display-format"];break;case"Edm.DateTimeOffset":t='sap.ui.model.odata.type.DateTimeOffset';break;case"Edm.Decimal":t='sap.ui.model.odata.type.Decimal';c.precision=o.precision;c.scale=o.scale;break;case"Edm.Double":t='sap.ui.model.odata.type.Double';break;case"Edm.Guid":t='sap.ui.model.odata.type.Guid';break;case"Edm.Int16":t='sap.ui.model.odata.type.Int16';break;case"Edm.Int32":t='sap.ui.model.odata.type.Int32';break;case"Edm.Int64":t='sap.ui.model.odata.type.Int64';break;case"Edm.SByte":t='sap.ui.model.odata.type.SByte';break;case"Edm.Single":case"Edm.Float":t='sap.ui.model.odata.type.Single';break;case"Edm.String":t='sap.ui.model.odata.type.String';c.maxLength=o.maxLength;break;case"Edm.Time":t='sap.ui.model.odata.type.Time';break;default:}c.nullable=o.nullable;}}if(w){R.value="{path : "+s(p)+", type : '"+t+"', constraints : "+s(c)+"}";}else if(r.test(p)){R.value="{path : "+s(p)+"}";}else{R.value="{"+p+"}";}return R;}function k(R,n){q.sap.log.warning("Illegal value for "+n+": "+R[n],null,"sap.ui.model.odata.AnnotationHelper");return d(R[n]);}function s(v){var S=JSON.stringify(v),E=false,R="",i,c;for(i=0;i<S.length;i+=1){switch(c=S.charAt(i)){case"'":R+="\\'";break;case'"':if(E){R+=c;E=false;}else{R+="'";}break;case"\\":if(E){R+="\\\\";}E=!E;break;default:if(E){R+="\\";E=false;}R+=c;}}return R;}function u(R,S){var t;if(typeof R==="object"){try{t="Unsupported: "+s(R);}catch(c){t=String(R);}}else{t=String(R);}return S?t:e(t);}function l(i,p){var P=[],o=p&&p[0],c;if(!o){return undefined;}P.push('{=odata.uriEncode(');switch(o.Type){case"Path":P.push('$');c=j(i,o.Value,false);P.push(c.value);P.push(", '");P.push(c.type);P.push("'");break;case"String":P.push(s(o.Value));P.push(", 'Edm.String'");break;default:P.push(s("[Unsupported: "+s(o)+"]"));P.push(", 'Edm.String'");}P.push(')}');return P.join("");}A={format:function(i,R){var c;if(R&&R.hasOwnProperty("String")){if(typeof R.String==="string"){if(i.getSetting&&i.getSetting("bindTexts")){c="/##"+i.getPath()+"/String";return j(i,c,false).value;}return e(R.String);}return k(R,"String");}if(R&&R.hasOwnProperty("Path")){if(typeof R.Path==="string"){return j(i,R.Path,true).value;}return k(R,"Path");}if(R&&R.Apply&&typeof R.Apply==="object"){switch(R.Apply.Name){case"odata.concat":if(q.isArray(R.Apply.Parameters)){return b(i,R.Apply.Parameters);}break;case"odata.fillUriTemplate":c=g(i,R.Apply.Parameters);if(c){return c;}break;case"odata.uriEncode":c=l(i,R.Apply.Parameters);if(c){return c;}break;}}return u(R);},getNavigationPath:function(i,R){var o=h(i,R);return o?"{"+o.navigationProperties.join("/")+"}":"";},gotoEntitySet:function(c){var E,R=c.getObject(),o;if(typeof R==="string"){E=R;}else{o=h(c,R);E=o&&o.associationSetEnd&&o.associationSetEnd.entitySet;}return E?c.getModel().getODataEntitySet(E,true):undefined;},gotoEntityType:function(c){return c.getModel().getODataEntityType(c.getProperty(""),true);},isMultiple:function(i,R){var o=h(i,R);if(o){if(o.navigationAfterMultiple){throw new Error('Association end with multiplicity "*" is not the last one: '+R.AnnotationPath);}return String(o.isMultiple);}return"";},resolvePath:function(c){var R=h(c,c.getObject());return R?R.resolvedPath:undefined;},simplePath:function(i,R){if(R&&R.hasOwnProperty("Path")){if(typeof R.Path==="string"){return j(i,R.Path,false).value;}return k(R,"Path");}return u(R);}};A.format.requiresIContext=true;A.getNavigationPath.requiresIContext=true;A.isMultiple.requiresIContext=true;A.simplePath.requiresIContext=true;return A;},true);
