/*!
 * SAP UI development toolkit for HTML5 (SAPUI5/OpenUI5)
 * (c) Copyright 2009-2015 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/model/BindingMode','sap/ui/model/ClientContextBinding','sap/ui/model/json/JSONListBinding','sap/ui/model/json/JSONModel','sap/ui/model/json/JSONPropertyBinding','sap/ui/model/json/JSONTreeBinding','sap/ui/model/MetaModel'],function(B,C,J,a,b,c,M){"use strict";var O=M.extend("sap.ui.model.odata.ODataMetaModel",{constructor:function(m,A){M.apply(this);this.sDefaultBindingMode=B.OneTime;this.mSupportedBindingModes={"OneTime":true};this.oModel=null;this.oLoadedPromise=l(this,m,A);},metadata:{publicMethods:["loaded"]}});function f(A,e,p){var I=-1;p=p||"name";jQuery.each(A||[],function(i,o){if(o[p]===e){I=i;return false;}});return I;}function d(A,e,p){var i=f(A,e,p);return i<0?null:A[i];}function g(m,A,q,e){var r=e?undefined:null,s,n,N;q=q||"";s=q.lastIndexOf(".");n=q.slice(0,s);N=q.slice(s+1);jQuery.each(m.getObject("/dataServices/schema")||[],function(i,S){if(S.namespace===n){jQuery.each(S[A]||[],function(j,t){if(t.name===N){r=e?t.$path:t;return false;}});return false;}});return r;}function l(t,m,A){function e(u,o){jQuery.each(o.extensions||[],function(i,E){if(E.namespace==="http://www.sap.com/Protocols/SAPData"){o["sap:"+E.name]=E.value;}});}function h(o,s,E){if(!o||o.isLoaded()){s();}else if(o.isFailed()){E(new Error("Error loading meta model"));}else{o.attachLoaded(s);o.attachFailed(function(i){E(new Error("Error loading meta model: "+i.getParameter("message")));});}}function v(i,j,n){jQuery.each(i||[],function(u,o){e(u,o);jQuery.extend(o,j[o.name||o.role]);if(n){n(o);}});}function k(A,D){function n(q,i){var o=i?A.EntityContainer:A.propertyAnnotations;return o&&o[q]||{};}jQuery.each(D.dataServices.schema||[],function(i,s){function o(p,I,q){var P=s[p];jQuery.each(P||[],function(j,r){var Q=s.namespace+"."+r.name,u=n(Q,I);e(j,r);jQuery.extend(r,A[Q]);r.$path="/dataServices/schema/"+i+"/"+p+"/"+j;q(r,u);});}e(i,s);jQuery.extend(s,A[s.namespace]);o("association",false,function(j,p){v(j.end,p);});o("complexType",false,function(j,p){v(j.property,p);});o("entityContainer",true,function(E,j){function p(F){var q=s.namespace+"."+E.name,r=A.EntityContainer&&A.EntityContainer[q]||{};jQuery.each(F.parameter||[],function(u,P){e(u,P);jQuery.extend(P,r[F.name+"/"+P.name]);});}v(E.associationSet,j);v(E.entitySet,j);v(E.functionImport,j,p);});o("entityType",false,function(E,j){v(E.property,j);v(E.navigationProperty,j);});});}return new Promise(function(r,R){h(m,function(){h(A,function(){try{var D=JSON.parse(JSON.stringify(m.getServiceMetadata()));k(A?A.getAnnotationsData():{},D);t.oModel=new a(D);t.oModel.setDefaultBindingMode(t.sDefaultBindingMode);r();}catch(i){R(i);}},R);},R);});}O.prototype._getObject=function(p,o){var i,n=o,P,r=p||"";if(!o||o instanceof sap.ui.model.Context){r=this.resolve(p||"",o);if(!r){jQuery.sap.log.error("Invalid relative path w/o context",p,"sap.ui.model.odata.ODataMetaModel");return null;}}if(r.charAt(0)==="/"){n=this.oModel._getObject("/");r=r.slice(1);}if(r){P=r.split("/");for(i=0;i<P.length;i+=1){if(!n){if(jQuery.sap.log.isLoggable(jQuery.sap.log.Level.WARNING)){jQuery.sap.log.warning("Invalid part: "+P[i],"path: "+p+", context: "+(o instanceof sap.ui.model.Context?o.getPath():o),"sap.ui.model.odata.ODataMetaModel");}break;}n=n[P[i]];}}return n;};O.prototype.bindContext=function(p,o,P){return new C(this,p,o,P);};O.prototype.bindList=function(p,o,s,F,P){return new J(this,p,o,s,F,P);};O.prototype.bindProperty=function(p,o,P){return new b(this,p,o,P);};O.prototype.bindTree=function(p,o,F,P){return new c(this,p,o,F,P);};O.prototype.destroy=function(){M.prototype.destroy.apply(this,arguments);return this.oModel.destroy.apply(this.oModel,arguments);};O.prototype.getMetaContext=function(p){var A,e,E,m,n,P,q;function s(S){var i=S.indexOf("(");return i>=0?S.slice(0,i):S;}if(!p){return null;}P=p.split("/");if(P[0]!==""){throw new Error("Not an absolute path: "+p);}P.shift();e=this.getODataEntitySet(s(P[0]));if(!e){throw new Error("Entity set not found: "+P[0]);}P.shift();q=e.entityType;while(P.length){E=this.getODataEntityType(q);n=s(P[0]);A=this.getODataAssociationEnd(E,n);if(A){q=A.type;if(A.multiplicity==="1"&&n!==P[0]){throw new Error("Multiplicity is 1: "+P[0]);}P.shift();}else{m=this.getODataProperty(E,P,true);if(P.length){throw new Error("Property not found: "+P.join("/"));}break;}}m=m||this.getODataEntityType(q,true);return this.createBindingContext(m);};O.prototype.getODataAssociationEnd=function(e,n){var N=e?d(e.navigationProperty,n):null,A=N?g(this.oModel,"association",N.relationship):null,o=A?d(A.end,N.toRole,"role"):null;return o;};O.prototype.getODataAssociationSetEnd=function(e,n){var A,o=null,E=this.getODataEntityContainer(),N=e?d(e.navigationProperty,n):null;if(E&&N){A=d(E.associationSet,N.relationship,"association");o=A?d(A.end,N.toRole,"role"):null;}return o;};O.prototype.getODataComplexType=function(q,A){return g(this.oModel,"complexType",q,A);};O.prototype.getODataEntityContainer=function(A){var r=A?undefined:null;jQuery.each(this.oModel.getObject("/dataServices/schema")||[],function(i,s){var j=f(s.entityContainer,"true","isDefaultEntityContainer");if(j>=0){r=A?"/dataServices/schema/"+i+"/entityContainer/"+j:s.entityContainer[j];return false;}});return r;};O.prototype.getODataEntitySet=function(n,A){var k,e=this.getODataEntityContainer(),r=A?undefined:null;if(e){k=f(e.entitySet,n);if(k>=0){r=A?e.$path+"/entitySet/"+k:e.entitySet[k];}}return r;};O.prototype.getODataEntityType=function(q,A){return g(this.oModel,"entityType",q,A);};O.prototype.getODataProperty=function(t,n,A){var i,p=jQuery.isArray(n)?n:[n],P=null,s;while(t&&p.length){i=f(t.property,p[0]);if(i<0){break;}p.shift();P=t.property[i];s=t.$path+"/property/"+i;if(p.length){t=this.getODataComplexType(P.type);}}return A?s:P;};O.prototype.getProperty=function(){return this._getObject.apply(this,arguments);};O.prototype.isList=function(){return this.oModel.isList.apply(this.oModel,arguments);};O.prototype.loaded=function(){return this.oLoadedPromise;};O.prototype.refresh=function(){throw new Error("Unsupported operation: ODataMetaModel#refresh");};O.prototype.setLegacySyntax=function(L){if(L){throw new Error("Legacy syntax not supported by ODataMetaModel");}};O.prototype.setProperty=function(){throw new Error("Unsupported operation: ODataMetaModel#setProperty");};return O;},true);
